$(document).ready(function() {

	// hide old content, load, display new content
	function navigateTo(hash) {
		$("nav a").each(function() {
			var href = $(this).attr("href").split("/").pop();
			if (hash == href.substr(0, href.length - 5)) {
				// check if it"s already the opened page
				if ($(this).hasClass("active") == false) {
					var toLoad = $(this).attr("href") + " #content";
					// update active item
					$(this).siblings().removeClass("active");
					$(this).addClass("active");
					// update page title
					document.title = document.title.split(" | ").slice(0,2).join(" | ") + " | " + hash.charAt(0).toUpperCase() + hash.slice(1);
					// track page view
					_gaq.push(["_trackPageview", $(this).attr("href")]);
					// start transition
					hideContent();
				}
				return false;
			}
			function hideContent() {
		        $("#content").animate({opacity:"toggle", height:"toggle"}, "slow", loadContent);
			}
			function loadContent() {
				$("#content").load(toLoad, showContent);
			}
			function showContent() {
				$("#content").animate({opacity:"toggle", height:"toggle"}, "normal");
			}
		});
	}
	
	// just prevent default
	function onDetailSwitch(event) {
		event.preventDefault();
	}
	
	function showVCardLabel() {
	    $("#vcard a span").show();
	    $("#vcard a span").animate({top: "+=8px", opacity: 1}, 250 );
	}

	function hideVCardLabel() {
	    $("#vcard a span").animate({top: "+=8px", opacity: 0}, 250, onComplete);
	    function onComplete(){
	    	$(this).hide();
		    $(this).css("top", "-50px");
	    }
	}
	
	// prevent default link action and switch language
	function onLanguageSwitch (event) {
		event.preventDefault();
		var href = $(this).attr("href").split("/").slice(0,2).join("/");
		var hash = "/" + window.location.hash;
		window.location = href + hash;
	}
	// prevent default link action and update hash
	function onNavigationClick(event) {
		event.preventDefault();
		var href = $(this).attr("href").split("/").pop();
		var hash = href.substr(0, href.length - 5);
		window.location.hash = hash;
	}
	// detect an hash change and trigger navigation
	function onHashChange(event) {
		if (!event.fragment) {
			var href = window.location.pathname.split("/").pop();
			var page = (href == "") ? "about" : href.substr(0, href.length - 5);
		}
		navigateTo(event.fragment || page);
	}
	
	// user interactions
	$("menu a").click(onLanguageSwitch);
	$("nav a").click(onNavigationClick);
	$("summary a").click(onDetailSwitch);
	$("#vcard a").hover(showVCardLabel, hideVCardLabel);
	
	// system events
	$(window).bind("hashchange", onHashChange);
	$(window).trigger("hashchange"); // trigger initial hash check
});